/**
 * This class was generated from a set of XML constraints
 *   by the Enhydra Zeus XML Data Binding Framework. All
 *   source code in this file is constructed specifically
 *   to work with other Zeus-generated classes. If you
 *   modify this file by hand, you run the risk of breaking
 *   this interoperation, as well as introducing errors in
 *   source code compilation.
 *
 * * * * * MODIFY THIS FILE AT YOUR OWN RISK * * * * *
 *
 * To find out more about the Enhydra Zeus framework, you
 *   can point your browser at <http://zeus.enhydra.org>
 *   where you can download releases, join and discuss Zeus
 *   on user and developer mailing lists, and access source
 *   code. Please report any bugs through that website.
 */
package org.objectweb.jonas_client.deployment.xml;

// Global Interface Import Statements
import java.io.File;
import java.io.IOException;
import java.io.OutputStream;
import java.io.Writer;

// Local Interface Import Statements
import java.util.List;
import java.io.Serializable;

public interface ApplicationClient extends Serializable {

    public static final String ZEUS_XML_NAME = "application-client";
    public static final String[] ZEUS_ATTRIBUTES = {"id"};
    public static final String[] ZEUS_ELEMENTS = {"icon", "display-name", "description", "env-entry", "ejb-ref", "resource-ref", "resource-env-ref", "callback-handler"};

    public Icon getIcon();

    public void setIcon(Icon icon);

    public DisplayName getDisplayName();

    public void setDisplayName(DisplayName displayName);

    public Description getDescription();

    public void setDescription(Description description);

    public List getEnvEntryList();

    public void setEnvEntryList(List envEntryList);

    public void addEnvEntry(EnvEntry envEntry);

    public void removeEnvEntry(EnvEntry envEntry);

    public List getEjbRefList();

    public void setEjbRefList(List ejbRefList);

    public void addEjbRef(EjbRef ejbRef);

    public void removeEjbRef(EjbRef ejbRef);

    public List getResourceRefList();

    public void setResourceRefList(List resourceRefList);

    public void addResourceRef(ResourceRef resourceRef);

    public void removeResourceRef(ResourceRef resourceRef);

    public List getResourceEnvRefList();

    public void setResourceEnvRefList(List resourceEnvRefList);

    public void addResourceEnvRef(ResourceEnvRef resourceEnvRef);

    public void removeResourceEnvRef(ResourceEnvRef resourceEnvRef);

    public CallbackHandler getCallbackHandler();

    public void setCallbackHandler(CallbackHandler callbackHandler);

    public String getId();

    public void setId(String id);

    public void marshal(File file) throws IOException;

    public void marshal(OutputStream outputStream) throws IOException;

    public void marshal(Writer writer) throws IOException;

    public void setDocType(String name, String publicID, String systemID);

    public void setOutputEncoding(String outputEncoding);

}
