/**
 * This class was generated from a set of XML constraints
 *   by the Enhydra Zeus XML Data Binding Framework. All
 *   source code in this file is constructed specifically
 *   to work with other Zeus-generated classes. If you
 *   modify this file by hand, you run the risk of breaking
 *   this interoperation, as well as introducing errors in
 *   source code compilation.
 *
 * * * * * MODIFY THIS FILE AT YOUR OWN RISK * * * * *
 *
 * To find out more about the Enhydra Zeus framework, you
 *   can point your browser at <http://zeus.enhydra.org>
 *   where you can download releases, join and discuss Zeus
 *   on user and developer mailing lists, and access source
 *   code. Please report any bugs through that website.
 */
package org.objectweb.jonas_web.deployment.xml;

// Global Interface Import Statements
import java.io.File;
import java.io.IOException;
import java.io.OutputStream;
import java.io.Writer;

// Local Interface Import Statements
import java.util.List;
import java.io.Serializable;

public interface Handler extends Serializable {

    public static final String ZEUS_XML_NAME = "handler";
    public static final String[] ZEUS_ATTRIBUTES = {"id"};
    public static final String[] ZEUS_ELEMENTS = {"description", "display-name", "small-icon", "large-icon", "handler-name", "handler-class", "init-param", "soap-header", "soap-role", "port-name"};

    public Description getDescription();

    public void setDescription(Description description);

    public DisplayName getDisplayName();

    public void setDisplayName(DisplayName displayName);

    public SmallIcon getSmallIcon();

    public void setSmallIcon(SmallIcon smallIcon);

    public LargeIcon getLargeIcon();

    public void setLargeIcon(LargeIcon largeIcon);

    public HandlerName getHandlerName();

    public void setHandlerName(HandlerName handlerName);

    public HandlerClass getHandlerClass();

    public void setHandlerClass(HandlerClass handlerClass);

    public List getInitParamList();

    public void setInitParamList(List initParamList);

    public void addInitParam(InitParam initParam);

    public void removeInitParam(InitParam initParam);

    public List getSoapHeaderList();

    public void setSoapHeaderList(List soapHeaderList);

    public void addSoapHeader(SoapHeader soapHeader);

    public void removeSoapHeader(SoapHeader soapHeader);

    public List getSoapRoleList();

    public void setSoapRoleList(List soapRoleList);

    public void addSoapRole(SoapRole soapRole);

    public void removeSoapRole(SoapRole soapRole);

    public List getPortNameList();

    public void setPortNameList(List portNameList);

    public void addPortName(PortName portName);

    public void removePortName(PortName portName);

    public String getId();

    public void setId(String id);

    public void marshal(File file) throws IOException;

    public void marshal(OutputStream outputStream) throws IOException;

    public void marshal(Writer writer) throws IOException;

    public void setDocType(String name, String publicID, String systemID);

    public void setOutputEncoding(String outputEncoding);

}
