/**
 * This class was generated from a set of XML constraints
 *   by the Enhydra Zeus XML Data Binding Framework. All
 *   source code in this file is constructed specifically
 *   to work with other Zeus-generated classes. If you
 *   modify this file by hand, you run the risk of breaking
 *   this interoperation, as well as introducing errors in
 *   source code compilation.
 *
 * * * * * MODIFY THIS FILE AT YOUR OWN RISK * * * * *
 *
 * To find out more about the Enhydra Zeus framework, you
 *   can point your browser at <http://zeus.enhydra.org>
 *   where you can download releases, join and discuss Zeus
 *   on user and developer mailing lists, and access source
 *   code. Please report any bugs through that website.
 */
package org.objectweb.jonas_ws.deployment.xml;

// Global Interface Import Statements
import java.io.File;
import java.io.IOException;
import java.io.OutputStream;
import java.io.Writer;

// Local Interface Import Statements
import java.util.List;
import java.io.Serializable;

public interface ServiceEndpointMethodMapping extends Serializable {

    public static final String ZEUS_XML_NAME = "service-endpoint-method-mapping";
    public static final String[] ZEUS_ATTRIBUTES = {"id"};
    public static final String[] ZEUS_ELEMENTS = {"java-method-name", "wsdl-operation", "method-param-parts-mapping", "wsdl-return-value-mapping"};

    public JavaMethodName getJavaMethodName();

    public void setJavaMethodName(JavaMethodName javaMethodName);

    public WsdlOperation getWsdlOperation();

    public void setWsdlOperation(WsdlOperation wsdlOperation);

    public List getMethodParamPartsMappingList();

    public void setMethodParamPartsMappingList(List methodParamPartsMappingList);

    public void addMethodParamPartsMapping(MethodParamPartsMapping methodParamPartsMapping);

    public void removeMethodParamPartsMapping(MethodParamPartsMapping methodParamPartsMapping);

    public WsdlReturnValueMapping getWsdlReturnValueMapping();

    public void setWsdlReturnValueMapping(WsdlReturnValueMapping wsdlReturnValueMapping);

    public String getId();

    public void setId(String id);

    public void marshal(File file) throws IOException;

    public void marshal(OutputStream outputStream) throws IOException;

    public void marshal(Writer writer) throws IOException;

    public void setDocType(String name, String publicID, String systemID);

    public void setOutputEncoding(String outputEncoding);

}
